/* indigo_design_system v1.0.0 */

codeSnippet = function() {
    'use strict';
    var set_event_listeners = function() {
        var clipboard = new Clipboard('.indi-code-snippet__copy'),
            clickedClass = 'indi-code-snippet__copy--clicked',
            copiedResponseSelector = '.indi-code-snippet__copied-response',
            copySuccessText = 'Copied!',
            copyErrorText = 'Press Ctrl + C to copy';

        clipboard.on('success', function(e) {
            $(e.trigger).removeClass(clickedClass);
            $(e.trigger)[0].offsetHeight;
            $(e.trigger).addClass(clickedClass).find(copiedResponseSelector).text(copySuccessText);
            e.clearSelection();
        });

        clipboard.on('error', function(e) {
            $(e.trigger).removeClass(clickedClass);
            $(e.trigger)[0].offsetHeight;
            $(e.trigger).addClass(clickedClass).find(copiedResponseSelector).text(copyErrorText);
        });

        $("body").on("click", '.indi-code-snippet__copy', function(e){
            e.preventDefault();
        });
    };

    var initialize = function initialize() {
        set_event_listeners();
    };

    var public_vars = {
        'initialize': initialize
    };

    return public_vars;
}();


$(document).ready(function(){
    'use strict';
    codeSnippet.initialize();
});

/*global $*/

var DocJumpMenu = function() {
    'use strict';

    if ($('.indi-jump-menu').length) {
        var currentPathname = window.location.pathname;

        $('.js-behavior-sink-page-link').click(function(e){
            e.preventDefault();
            var sinkPathname = currentPathname.replace('components', 'sink-pages');
            // window.location.href = sinkPathname;
            window.open(sinkPathname, '_blank');
        });

        var marginSize = 32;
        var headerHeight = 108;

        var jumpMenuInitialPosition = $('.indi-jump-menu').offset().top;

        $(window).scroll(function() {
            var scroll = $(window).scrollTop();

            if (scroll >= jumpMenuInitialPosition - (marginSize + headerHeight)) {
                $('.indi-jump-menu').addClass('indi-jump-menu--is-fixed');
            } else {
                $('.indi-jump-menu').removeClass('indi-jump-menu--is-fixed');
            }

            var scrollSpyTarget;

            $('.js-jump-menu-object').each(function(){
                var thisOffsetWithMargin = $(this).offset().top - (marginSize + headerHeight);

                if (scroll >= thisOffsetWithMargin && thisOffsetWithMargin + $(this).height() > scroll) {
                    scrollSpyTarget = $(this).attr('id');
                    $('.indi-jump-menu__link').removeClass('indi-jump-menu__link--is-active');
                    $('.js-behavior-jump-link[href="#' + scrollSpyTarget + '"]').addClass('indi-jump-menu__link--is-active');
                    // console.log(
                    //     'scroll:', scroll,
                    //     $(this).attr('id'), $(this).offset().top,
                    //     'this height:', $(this).height(),
                    //     'viewport height:', $(window).height(),
                    //     $(this).offset().top + $(this).height(),
                    //     'scrollSpyTarget', scrollSpyTarget
                    // );
                }
            });
        });

        $('.js-behavior-jump-link').click(function(e){
            e.preventDefault();
            var $this = $(this);
            var jumpMenuTarget = $this.attr('href');

            $('html, body').animate({
                'scrollTop': $(jumpMenuTarget).offset().top - (marginSize + headerHeight)
            }, 500, function(){
                $('.indi-jump-menu__link').removeClass('indi-jump-menu__link--is-active');
                $this.addClass('indi-jump-menu__link--is-active');
            });

            window.location.hash = jumpMenuTarget;
        });
    }
};

$(document).ready(function(){
    'use strict';
    DocJumpMenu = new DocJumpMenu();
});
